###################################################
### chunk number 1: 
###################################################
options(width=74)
library(xtable)


###################################################
### chunk number 2: <
###################################################
library(rcdk)


###################################################
### chunk number 3:  eval=FALSE
###################################################
## library(help=rcdk)


###################################################
### chunk number 4:  eval=FALSE
###################################################
## mols <- load.molecules( c('data1.sdf', '/some/path/data2.sdf') )


###################################################
### chunk number 5:  eval=FALSE
###################################################
## iter <- iload.molecules('verybig.sdf', type='sdf')
## while(hasNext(iter)) {
##  mol <- nextElem(iter)
##  print(get.property(mol, "cdk:Title"))
## }


###################################################
### chunk number 6: 
###################################################
smile <- 'c1ccccc1CC(=O)C(N)CC1CCCCOC1'
mol <- parse.smiles(smile)[[1]]


###################################################
### chunk number 7: 
###################################################
smiles <- c('CCC', 'c1ccccc1', 'CCCC(C)(C)CC(=O)NC')
mols <- parse.smiles(smiles)


###################################################
### chunk number 8:  eval=FALSE
###################################################
## options("java.parameters"=c("-Xmx4000m"))
## library(rcdk)
## 
## for (smile in smiles) {
##   m <- parse.smiles(smile)
##   ## perform operations on this molecule
##   
##   jcall("java/lang/System","V","gc")
##   gc()
## }


###################################################
### chunk number 9:  eval=FALSE
###################################################
## write.molecules(mols, filename='mymols.sdf')


###################################################
### chunk number 10:  eval=FALSE
###################################################
## write.molecules(mols, filename='mymols.sdf', together=FALSE)


###################################################
### chunk number 11: 
###################################################
get.smiles(mols[[1]])
unlist(lapply(mols, get.smiles))


###################################################
### chunk number 12:  eval=FALSE
###################################################
## smiles <- c('CCC', 'CCN', 'CCN(C)(C)',
##             'c1ccccc1Cc1ccccc1',
##             'C1CCC1CC(CN(C)(C))CC(=O)CC')
## mols <- parse.smiles(smiles)
## view.molecule.2d(mols[[1]])
## view.molecule.2d(mols)


###################################################
### chunk number 13:  eval=FALSE
###################################################
## dframe <- data.frame(x = runif(4),
##                      toxicity = factor(c('Toxic', 'Toxic', 'Nontoxic', 'Nontoxic')),
##                      solubility = c('yes', 'yes', 'no', 'yes'))
## view.table(mols[1:4], dframe)


###################################################
### chunk number 14: 
###################################################
mol <- parse.smiles('c1ccccc1')[[1]]
set.property(mol, "title", "Molecule 1")
set.property(mol, "hvyAtomCount", 6)
get.property(mol, "title")


###################################################
### chunk number 15: 
###################################################
get.properties(mol)


###################################################
### chunk number 16:  eval=FALSE
###################################################
## write.molecules(mol, 'tagged.sdf', write.props=TRUE)


###################################################
### chunk number 17: 
###################################################
mol <- parse.smiles('c1ccccc1C(Cl)(Br)c1ccccc1')[[1]]
atoms <- get.atoms(mol)
bonds <- get.bonds(mol)
cat('No. of atoms =', length(atoms), '\n')
cat('No. of bonds =', length(bonds), '\n')


###################################################
### chunk number 18: 
###################################################
unlist(lapply(atoms, get.symbol))


###################################################
### chunk number 19: 
###################################################
coords <- get.point3d(atoms[[1]])


###################################################
### chunk number 20:  eval=FALSE
###################################################
## coords <- do.call('rbind', lapply(atoms, get.point3d))


###################################################
### chunk number 21:  eval=FALSE
###################################################
## if ( any(apply(coords, 2, function(x) length(unique(x))) == 1) ) {
##   print("molecule is flat")
## }


###################################################
### chunk number 22: 
###################################################
mols <- parse.smiles(c('CC(C)(C)C','c1ccc(Cl)cc1C(=O)O', 'CCC(N)(N)CC'))
query <- '[#6D2]'
hits <- match(query, mols)
print(hits)


###################################################
### chunk number 23: 
###################################################
dc <- get.desc.categories()
dc


###################################################
### chunk number 24: 
###################################################
dn <- get.desc.names(dc[1])


###################################################
### chunk number 25: 
###################################################
aDesc <- eval.desc(mol, dn[1])
allDescs <- eval.desc(mol, dn)


###################################################
### chunk number 26: 
###################################################
data(bpdata)
mols <- parse.smiles(bpdata[,1])
descNames <- unique(unlist(sapply(get.desc.categories(), get.desc.names)))
descs <- eval.desc(mols, descNames) 
class(descs)
dim(descs)


###################################################
### chunk number 27: 
###################################################
mol <- parse.smiles('CC(=O)CC(=O)NCN')[[1]]
convert.implicit.to.explicit(mol)
get.tpsa(mol)
get.xlogp(mol)
get.alogp(mol)


###################################################
### chunk number 28:  eval=FALSE
###################################################
## descs <- descs[, !apply(descs, 2, function(x) any(is.na(x)) )]
## descs <- descs[, !apply( descs, 2, function(x) length(unique(x)) == 1 )]
## r2 <- which(cor(descs)^2 > .6, arr.ind=TRUE)
## r2 <- r2[ r2[,1] > r2[,2] , ]
## descs <- descs[, -unique(r2[,2])]


###################################################
### chunk number 29: 
###################################################
model <- lm(BP ~ khs.sCH3 + khs.sF + apol + nHBDon, data.frame(bpdata, descs))
summary(model)


###################################################
### chunk number 30: 
###################################################
par(mar=c(4.3,4.3,1,1),cex.lab=1.3, pty='s')
plot(bpdata$BP, model$fitted, pch=19, 
     ylab='Predicted BP', xlab='Observed BP',
     xlim=range(bpdata$BP), ylim=range(bpdata$BP))
abline(0,1, col='red')


###################################################
### chunk number 31: 
###################################################
smiles <- c('CCC', 'CCN', 'CCN(C)(C)', 
            'c1ccccc1Cc1ccccc1',
            'C1CCC1CC(CN(C)(C))CC(=O)CC')
mols <- parse.smiles(smiles)
fp <- get.fingerprint(mols[[1]], type='maccs')


###################################################
### chunk number 32: 
###################################################
mols <- parse.smiles(bpdata[1:50,1]) 
fps <- lapply(mols, get.fingerprint, type='extended') 
fp.sim <- fp.sim.matrix(fps, method='tanimoto') 
fp.dist <- 1 - fp.sim 


###################################################
### chunk number 33: 
###################################################
clustering <- hclust(as.dist(fp.dist))
plot(clustering, main='A Clustering of the BP dataset')


###################################################
### chunk number 34: 
###################################################
query.mol <- parse.smiles('CC(=O)')[[1]]
target.mols <- parse.smiles(bpdata[,1])
query.fp <- get.fingerprint(query.mol, type='maccs')
target.fps <- lapply(target.mols, get.fingerprint, type='maccs')
sims <- unlist(lapply(target.fps, 
                      distance, 
                      fp2=query.fp, method='tanimoto'))
hits <- which(sims > 0.3)


###################################################
### chunk number 35: 
###################################################
d <- data.frame(SMILES=bpdata[hits,1], Similarity=sims[hits])
row.names(d) <- NULL
d <- d[sort.list(d[,2], dec=TRUE),]
xtable(d, label="tab:sims", 
       caption="Summary of molecules in the BP dataset that are greater than 0.3 similar to acetaldehyde")


###################################################
### chunk number 36: 
###################################################
sp <- get.smiles.parser()
molecule <- parse.smiles('N')[[1]]
convert.implicit.to.explicit(molecule)
formula <- get.mol2formula(molecule,charge=0)


###################################################
### chunk number 37: 
###################################################
formula@mass


###################################################
### chunk number 38: 
###################################################
formula@charge


###################################################
### chunk number 39: 
###################################################
formula@isotopes


###################################################
### chunk number 40: 
###################################################
formula@objectJ


###################################################
### chunk number 41: 
###################################################
formula@string


###################################################
### chunk number 42:  eval=FALSE
###################################################
## formula <- set.charge.formula(formula, charge=1)


###################################################
### chunk number 43: 
###################################################
formula <- get.formula('NH4', charge = 1);
formula


###################################################
### chunk number 44: 
###################################################
mfSet <- generate.formula(18.03383, window=1, 
		elements=list(c("C",0,50),c("H",0,50),c("N",0,50)), 
		validation=FALSE);
for (i in 1:length(mfSet)) {
  print(mfSet[i])
}


###################################################
### chunk number 45: 
###################################################
formula <- get.formula('NH4', charge = 0);
isvalid.formula(formula,rule=c("nitrogen","RDBE"))


###################################################
### chunk number 46: 
###################################################
formula <- get.formula('CHCl3', charge = 0) 
isotopes <- get.isotopes.pattern(formula,minAbund=0.1)
isotopes


###################################################
### chunk number 47: 
###################################################
plot(isotopes, type="h", xlab="m/z", ylab="Intensity")


